Index: trunk/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1314)
+++ trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1321)
@@ -531,4 +531,37 @@
         pcCU->getCUMvField( REF_PIC_LIST_1 )->setMvFieldSP(pcCU, uiSPAddr, pcMvFieldSP[2*iPartitionIdx + 1], iSPWidth, iSPHeight);
       }
+#if ENC_DEC_TRACE && H_MV_ENC_DEC_TRAC
+      if ( g_traceSubPBMotion )
+      {
+        std::cout << std::setfill(' ')                          << std::setw( 15 )
+          << "Num"                                              << std::setw( 15 )
+          << "Dir "                                             << std::setw( 15 )
+          <<  "L0 RefIdx"                                       << std::setw( 15 )
+          <<  "L0 Hor"                                          << std::setw( 15 )
+          <<  "L0 Ver"                                          << std::setw( 15 )
+          <<  "L1 RefIdx"                                       << std::setw( 15 )
+          <<  "L1 Hor"                                          << std::setw( 15 )
+          <<  "L1 Ver"                                          << std::setw( 15 )
+          << std::endl; 
+
+        for (Int iPartitionIdx = 0; iPartitionIdx < iNumSP; iPartitionIdx++)
+        {
+          UChar        dir = puhInterDirSP[iPartitionIdx]; 
+          TComMvField& mv0 = pcMvFieldSP  [2*iPartitionIdx];
+          TComMvField& mv1 = pcMvFieldSP  [2*iPartitionIdx+1];
+
+          std::cout << std::setfill(' ')                                  << std::setw( 15 )
+            << iPartitionIdx                                              << std::setw( 15 )
+            << (UInt) dir                                                 << std::setw( 15 )
+            << ((dir & 1) ? mv0.getRefIdx()       : MIN_INT)              << std::setw( 15 )
+            << ((dir & 1) ? mv0.getMv().getHor()  : MIN_INT)              << std::setw( 15 )
+            << ((dir & 1) ? mv0.getMv().getVer()  : MIN_INT)              << std::setw( 15 )
+            << ((dir & 2) ? mv1.getRefIdx()       : MIN_INT)              << std::setw( 15 )
+            << ((dir & 2) ? mv1.getMv().getHor()  : MIN_INT)              << std::setw( 15 )
+            << ((dir & 2) ? mv1.getMv().getVer()  : MIN_INT)              << std::setw( 15 )
+            << std::endl;
+        }
+      }
+#endif
     }
     delete[] pcMvFieldSP;
@@ -779,4 +812,5 @@
   const ChromaFormat chFmt     = rTu.GetChromaFormat();
 
+  DEBUG_STRING_NEW(sTemp)
   if ( pcCU->getDISType(uiAbsPartIdx) == 0 )
   {
@@ -1271,4 +1305,5 @@
     TComTURecurse tuRecurseWithPU(tuRecurseCU, false, TComTU::DONT_SPLIT);
 
+    DEBUG_STRING_NEW(sTemp)
     m_pcPrediction->initIntraPatternChType( tuRecurseWithPU, COMPONENT_Y, false DEBUG_STRING_PASS_INTO(sTemp) );
 
@@ -1321,5 +1356,5 @@
       
       //===== init pattern for luma prediction =====
-      
+      DEBUG_STRING_NEW(sTemp)
       m_pcPrediction->initIntraPatternChType( tuRecurseWithPU, COMPONENT_Y, bUseFilter  DEBUG_STRING_PASS_INTO(sTemp) );
       
Index: trunk/source/Lib/TLibDecoder/TDecEntropy.h
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecEntropy.h	(revision 1314)
+++ trunk/source/Lib/TLibDecoder/TDecEntropy.h	(revision 1321)
@@ -67,5 +67,10 @@
   virtual Void  parseSPS                  ( TComSPS* pcSPS )     = 0;
   virtual Void  parsePPS                  ( TComPPS* pcPPS )     = 0;
-  virtual Void parseSliceHeader          ( TComSlice* pcSlice, ParameterSetManager *parameterSetManager, const Int prevTid0POC)       = 0;
+#if NH_MV
+  virtual Void  parseFirstSliceSegmentInPicFlag( TComSlice* pcSlice ) = 0;
+  virtual Void  parseSliceHeader          ( TComSlice* pcSlice, ParameterSetManager *parameterSetManager )       = 0;
+#else
+  virtual Void  parseSliceHeader          ( TComSlice* pcSlice, ParameterSetManager *parameterSetManager, const Int prevTid0POC)       = 0;
+#endif
 
   virtual Void parseTerminatingBit       ( UInt& ruilsLast )                                     = 0;
@@ -156,5 +161,12 @@
   Void    decodeSPS                   ( TComSPS* pcSPS ) { m_pcEntropyDecoderIf->parseSPS(pcSPS); }
   Void    decodePPS                   ( TComPPS* pcPPS ) { m_pcEntropyDecoderIf->parsePPS(pcPPS); }
+#if NH_MV
+  Void    decodeFirstSliceSegmentInPicFlag ( TComSlice* pcSlice )  { m_pcEntropyDecoderIf->parseFirstSliceSegmentInPicFlag( pcSlice );         }
+#endif
+#if NH_MV
+  Void    decodeSliceHeader           ( TComSlice* pcSlice, ParameterSetManager *parameterSetManager )  { m_pcEntropyDecoderIf->parseSliceHeader(pcSlice, parameterSetManager);         }
+#else
   Void    decodeSliceHeader           ( TComSlice* pcSlice, ParameterSetManager *parameterSetManager, const Int prevTid0POC)  { m_pcEntropyDecoderIf->parseSliceHeader(pcSlice, parameterSetManager, prevTid0POC);         }
+#endif
   Void    decodeTerminatingBit        ( UInt& ruiIsLast )       { m_pcEntropyDecoderIf->parseTerminatingBit(ruiIsLast);     }
   Void    decodeRemainingBytes( Bool noTrailingBytesExpected ) { m_pcEntropyDecoderIf->parseRemainingBytes(noTrailingBytesExpected); }
Index: trunk/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 1314)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 1321)
@@ -80,5 +80,10 @@
   Void  parseSPS                  ( TComSPS* /*pcSPS*/ ) {}
   Void  parsePPS                  ( TComPPS* /*pcPPS*/ ) {}
+#if NH_MV
+  Void  parseFirstSliceSegmentInPicFlag( TComSlice* /*pcSlice*/ ) {}
+  Void  parseSliceHeader          ( TComSlice* /*pcSlice*/, ParameterSetManager* /*parameterSetManager*/ ) {}
+#else
   Void  parseSliceHeader          ( TComSlice* /*pcSlice*/, ParameterSetManager* /*parameterSetManager*/, const Int /*prevTid0POC*/) {}
+#endif
   Void  parseTerminatingBit       ( UInt& ruiBit );
   Void  parseRemainingBytes       ( Bool noTrailingBytesExpected);
